stages:
  - check
  - test
  - check_coverage
  - build
  - publish
  - tag

image: python:3.9

check_format:
  stage: check
  script:
    - make check_format
  except:
    - tags

lint:
  stage: check
  script:
    - make lint
  except:
    - tags

code_quality:
  stage: check
  script:
    - make code_quality

security_checks:
  stage: check
  script:
    - make security_checks

test:
  stage: test
  script:
    - make test
  when: on_success
  except:
    - tags
  needs:
    - check_format
    - lint
    - code_quality
    - security_checks
  artifacts:
    paths:
      - .coverage
    expire_in: 10 days

check_coverage:
  stage: check_coverage
  script:
    - make check_coverage
  dependencies:
    - test
  when: on_success

build:
  stage: build
  script:
    - make build
  when: on_success
  only:
    - main
  artifacts:
    paths:
      - dist/*
    expire_in: 10 days

publish:
  stage: publish
  script:
    - make publish
  dependencies:
    - build
  when: manual
  only:
    - main

tag:
  stage: tag
  image: ruby:3.1
  script:
    - set -e
    - version=$(awk -F '= ' '/^version = / { print $2 }' setup.cfg | tr -d '[:space:]')
    - export tag="v$version"
    - echo "Tagging the repository with tag:" $tag
    - git tag "$tag"
    - git push --tags https://${GIT_USERNAME}:${GIT_TOKEN}@${CI_SERVER_HOST}/${CI_PROJECT_PATH}.git
  when: on_success
  only:
    - main
  needs:
    - publish
